## Real-time Online/Offline Charging System (OCS) for Telecom & ISP environments

[![build & test](https://github.com/cgrates/cgrates/actions/workflows/build.yaml/badge.svg?branch=master)](https://github.com/cgrates/cgrates/actions/workflows/build.yaml)
[![integration](https://github.com/cgrates/cgrates/actions/workflows/integration_tests.yaml/badge.svg?branch=master)](https://github.com/cgrates/cgrates/actions/workflows/integration_tests.yaml)
[![Documentation Status](https://readthedocs.org/projects/cgrates/badge/?version=latest)](https://cgrates.readthedocs.io/en/latest/?badge=latest)
[![GoDoc](https://pkg.go.dev/badge/github.com/cgrates/cgrates)](https://pkg.go.dev/github.com/cgrates/cgrates@master)

### Features

- Real-time Online/Offline Charging System (OCS).
- Account Balances Management with bundle support.
- Session or Event charging with reservation.
- Rating engine.
- CDR logging with support for Interim Records.
- QoS LCR and LCR over Bundles.
- Fraud detection with automatic mitigation.
- Call Statistics with pattern monitoring.
- Performance oriented.
- Modular architecture.
- Test driven development.
- Plug-able/non-intrusive into existing setups.
- Cloud-ready, built on independent micro-services with rich set of RPC APIs.
- Agile in developing new features.
- Very fast (5000+ req/sec on a single machine)
- Good documentation.
- Commercial support available

### Documentation

[Step by steps tutorials](https://cgrates.readthedocs.io/en/latest/tutorial.html)

[Debian apt-get repository](https://cgrates.readthedocs.io/en/latest/installation.html#)

[Installing CGRateS from sources on minimal debian](https://asciinema.org/a/0lwlputceg52xssqgra7wjza0) (for devel or testing)

Browsable HTML docs http://readthedocs.org/docs/cgrates/

PDF, Epub, Manpage http://readthedocs.org/projects/cgrates/downloads/

API reference [godoc](https://pkg.go.dev/github.com/cgrates/cgrates/apier@master)
